Index: trunk/LMDZ.COMMON/build_gcm
===================================================================
--- trunk/LMDZ.COMMON/build_gcm	(revision 978)
+++ trunk/LMDZ.COMMON/build_gcm	(revision 979)
@@ -1,19 +1,48 @@
 #!/bin/bash
+# Usage:
+# ./build_gcm [path]
+# where 'path' is an optional argument to this script specifying
+# the full path to where the 'fcm' command is to be found
 
-if [[ -f '.lock' ]] ; then
-  echo 'ATTENTION: vous etes sans doute en train de compiler le modele par ailleurs'
-  echo "Attendez que la premiere compilation soit terminee pour relancer la suivante."
-  echo "Si vous etes sur que vous ne compilez pas le modele par ailleurs,"
-  echo  vous pouvez continuer en repondant oui.
-  echo "Voulez-vous vraiment continuer?"
-  read -p "" answer
-  if [[ $answer != "oui" ]] ; then
+if test -f '.lock' 
+  then
+    echo 'ATTENTION: vous etes sans doute en train de compiler le modele par ailleurs'
+    echo "Attendez que la premiere compilation soit terminee pour relancer la suivante."
+    echo "Si vous etes sur que vous ne compilez pas le modele par ailleurs,"
+    echo "vous pouvez continuer en repondant oui."
+    echo "Voulez-vous vraiment continuer?"
+    echo ""
+    echo "WARNING: you are probably already compiling the model somewhere else."
+    echo "Wait until the first compilation is finished before launching this one."
+    echo "If you are sure that you are not compiling elsewhere, just answer "
+    echo "yes (or 'oui') to the question below to proceed."
+    echo "Do you wish to continue?"
+    read ouinon
+    if [[ $ouinon == "oui" || $ouinon == "yes" ]] 
+	then
+	echo OK 
+    else
+	exit
+    fi
+else
+    echo "compiling..." > '.lock'
+fi
+
+dirname="" #path to where the fcm command will be found
+if (( $# >= 1 )) ; then
+  dirname=$1
+  # check that "dirname" exists and is a directory
+  if [[ ! -d $dirname ]] ; then
+    echo "$0 error : $dirname is not a directory"
     exit
   fi
-else
-  echo "compilation en cours..." > '.lock'
+  # add a trailing "/" to $dirname
+  dirname=${dirname}"/"
 fi
 
-fcm build
+# run "fcm build" command
+${dirname}fcm build
 
+# cleanup
 \rm -f '.lock' 
+
Index: trunk/LMDZ.COMMON/create_make_gcm
===================================================================
--- trunk/LMDZ.COMMON/create_make_gcm	(revision 978)
+++ trunk/LMDZ.COMMON/create_make_gcm	(revision 979)
@@ -4,4 +4,7 @@
 #
 #set -xv
+
+rm -f create_make_gcm.log
+
 machine=`hostname`
 os=`uname`
@@ -134,14 +137,14 @@
 do
    if [ -d $diri ] ; then
-   if [ "`ls $diri/*.F`" != "" ] || [ "`ls $diri/*.F90`" != "" ]  ; then 
-      cd $diri >/dev/null 2>&1
+   if [ "`ls $diri/*.F $diri/*/*.F`" != "" ] || [ "`ls $diri/*.F90 $diri/*/*.F90`" != "" ]  ; then 
+#      cd $diri >/dev/null 2>&1
       echo
       listlib=""
-      for i in `ls *.F`
-      do
-         fili=`basename $i .F`
+# Liste des fichiers .F et .F90 n'etant pas des programmes principaux
+      for fili in `ls $diri/*.F $diri/*/*.F`
+      do
          # Check if file is a routine or main program
          # i.e: look for the "program" keword preceeded by leading spaces
-         test=` (  head $i | grep -i '^ *program' ) `
+         test=` (  head $fili | grep -i '^ *program' ) `
          if [ "$test" = "" ] ; then 
             # if it is not a main program, add it to the list
@@ -149,10 +152,9 @@
          fi
       done
-      for i in `ls *.F90`
-      do
-         fili=`basename $i .F90`
+      for fili in `ls $diri/*.F90 $diri/*/*.F90`
+      do
          # Check if file is a routine or main program
          # i.e. look for "program" keyword (with possibly some leading spaces)
-         test=` (  head $i | grep -i '^ \{0,\}program' ) `
+         test=` (  head $fili | grep -i '^ \{0,\}program' ) `
          if [ "$test" = "" ] ; then
             # if it is not a main program, add it to the list
@@ -162,4 +164,5 @@
 #
       echo
+      echo $listlib >> create_make_gcm.log
       echo
       echo "#======================================================================="
@@ -167,6 +170,7 @@
       echo "#======================================================================="
       echo
-      for fili in $listlib
-      do
+      for trufile in $listlib
+      do
+         fili=`echo $trufile | awk -F/ ' { print $NF } ' | cut -d. -f1`
          echo '$(LIBO)/lib'$diri".a : " '$(LIBO)/lib'$diri".a("$fili".o)"
          echo
@@ -177,47 +181,53 @@
       echo "# Compilation des membres de la bibliotheque lib"$diri".a"
       echo
-      for fili in $listlib
-      do
-         if [ -f $fili.F90 ] ; then
-           trufile=$fili.F90
-         else
-           trufile=$fili.F
-         fi
+      for trufile in $listlib
+      do
+#         if [ -f $fili.F90 ] ; then
+#           trufile=$fili.F90
+#         else
+#           trufile=$fili.F
+#         fi
+         fili=`echo $trufile | awk -F/ ' { print $NF } ' | cut -d. -f1`
          F90=0 ; egrep -i '^ *use ' $trufile > /dev/null 2>&1 && F90=1
                  egrep -i '^ *module ' $trufile > /dev/null 2>&1 && F90=1
                  egrep -i '#include*.inc ' $trufile > /dev/null 2>&1 && F90=1
-         str1='$(LIBO)/lib'$diri'.a('$fili'.o) : $(LIBF)/'$diri/$trufile
+         str1='$(LIBO)/lib'$diri'.a('$fili'.o) : $(LIBF)/'$trufile
          [ "$fili" = "chem.subs" ] && str1=$str1' $(LIBF)/'$diri/chem.mods.F
-         for stri in ` ( sed -n "/\#include/s/\#include//p" $trufile | sed 's/\"//g' ; egrep -i '^ *use ' $trufile | sed -e 's/,/ /' | awk ' { print $2 } ' ) `
-         do
-
-
+
+##########################################################################
+# TRAITEMENT DES DEPENDANCES
 # Differents cas de dependance correspondant a des include ou des
 # use module.
 # soit dans le repertoire local soit dans un autre.
-
-            stri=`echo $stri | tr [A-Z] [a-z]`
-            if [ -f $stri ] ; then
+# Pour dyn3d, il faudrait remplacer la chaine de caractere par $DYN
+# ou quelque chose du genre.
+##########################################################################
+
+         for stri in ` ( sed -e '/^[cC\!]/d' $trufile | sed -n "/\#include/s/\#include//p" | sed 's/\"//g' ; sed -e '/^[cC\!]/d' $trufile | egrep -i '^ *use ' | sed -e 's/,/ /' | awk ' { print $2 } ' ) `
+         do
+            echo $trufile $fili $stri >> create_make_gcm.log
+            strj=`echo $stri | tr [A-Z] [a-z]`
+            str2=""
+            for dirinc in filtrez bibio grid dyn3d $diri $diri/*/ ; do
+# Recherche dans l'ordre hierarchique inverse car seule la derniere
+# ligne est conservee
+               if [ -f $dirinc/$stri ] ; then
+                  str2='$(LIBF)/'$dirinc/$stri
+               elif [ -f $dirinc/$strj ] ; then
+                  str2='$(LIBF)/'$dirinc/$stri
+               elif [ -f $dirinc/$strj.F90 ]  || [ -f $dirinc/$strj.F ]  ; then 
+                  strlib=`echo $dirinc | awk -F/ ' { print $1 } '`
+                  str2='$(LIBO)/lib'$strlib'.a('$strj'.o)'
+               fi
+            done
+            if [ "$str2" = "" ] ; then
+               echo Warn: Include $diri $trufile $fili $stri pas trouve >> $gcm/create_make_gcm.log
+            elif [ "$str2" = "$str1" ] ; then
+               echo Warn: Include $diri $trufile $fili $stri $str1 trouve 2x >> $gcm/create_make_gcm.log
+            else
                echo $str1 \\
-               str1='$(LIBF)/'$diri'/'$stri
-            else
-               if [ -f $stri.F ] || [ -f $stri.F90 ] ; then
-                  echo $str1 \\
-                  str1='$(LIBO)/lib'$diri'.a('$stri'.o)'
-               else
-                  for dirinc in dyn3d grid bibio filtrez
-                  do
-                     if [ -f ../$dirinc/$stri ] ; then
-                        echo $str1 \\
-                        str1='$(LIBF)/'`cd .. ; ls */$stri | head -1`
-                     fi
-                     if [ -f ../$dirinc/$stri.F90 ] ; then
-                        echo $str1 \\
-                        str1='$(LIBO)/lib'$dirinc'.a('$stri'.o)'
-                     fi
-                  done
-               fi
+               str1=$str2
             fi
-         done
+         done # Fin de la boucle sur les dependances et ecriture de la derniere
          echo $str1
          # Compile in LIBO directory; and before compiling, remove
@@ -227,12 +237,12 @@
 	 if [ "$F90" -eq '0' ] ; then
          ## Fixed Form Fortran 77
-	   echo '	$(COMPILE) $(LIBF)/'$diri'/'$trufile' ; \'
+	   echo '	$(COMPILE) $(LIBF)/'$trufile' ; \'
 	 else
          ## Fortran 90
            if [ -f $fili.F90 ] ; then
 	      ## Free Form
-              echo '	$(COMPTRU90) $(LIBF)/'$diri'/'$trufile' ; \'
+              echo '	$(COMPTRU90) $(LIBF)/'$trufile' ; \'
            else
-	      echo '	$(COMPILE90) $(LIBF)/'$diri'/'$trufile' ; \'
+	      echo '	$(COMPILE90) $(LIBF)/'$trufile' ; \'
            fi
 	 fi
Index: trunk/LMDZ.COMMON/libf/bibio/new_unit_m.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/bibio/new_unit_m.F90	(revision 979)
+++ trunk/LMDZ.COMMON/libf/bibio/new_unit_m.F90	(revision 979)
@@ -0,0 +1,25 @@
+module new_unit_m
+
+  implicit none
+
+contains
+
+  subroutine new_unit(unit)
+
+    integer, intent(out):: unit
+
+    ! Variables local to the procedure:
+    logical opened, exist
+
+    !------------------------------------------------------
+
+    unit = 0
+    do
+       inquire(unit=unit, opened=opened, exist=exist)
+       if (exist .and. .not. opened) exit
+       unit = unit + 1
+    end do
+
+  end subroutine new_unit
+
+end module new_unit_m
Index: trunk/LMDZ.COMMON/libf/bibio/pchfe_95_m.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/bibio/pchfe_95_m.F90	(revision 979)
+++ trunk/LMDZ.COMMON/libf/bibio/pchfe_95_m.F90	(revision 979)
@@ -0,0 +1,76 @@
+module PCHFE_95_m
+
+  implicit none
+
+contains
+
+  SUBROUTINE PCHFE_95(X, F, D, SKIP, XE, FE, IERR)
+
+    ! PURPOSE  Evaluate a piecewise cubic Hermite function at an array of
+    !            points.  May be used by itself for Hermite interpolation,
+    !            or as an evaluator for PCHIM or PCHIC.
+    ! CATEGORY  E3
+    ! KEYWORDS  CUBIC HERMITE EVALUATION, HERMITE INTERPOLATION, PCHIP,
+    !             PIECEWISE CUBIC EVALUATION
+
+    !          PCHFE:  Piecewise Cubic Hermite Function Evaluator
+    ! Evaluates the cubic Hermite function defined by  X, F, D  at
+    ! the points  XE.
+
+    use assert_eq_m, only: assert_eq
+
+    REAL, intent(in):: X(:) ! real array of independent variable values
+    ! The elements of X must be strictly increasing.
+
+    REAL, intent(in):: F(:) ! real array of function values
+    ! F(I) is the value corresponding to X(I).
+
+    REAL, intent(in):: D(:) ! real array of derivative values
+    ! D(I) is the value corresponding to X(I).
+
+    LOGICAL, intent(inout):: SKIP 
+    ! request to skip checks for validity of "x"
+    ! If "skip" is false then "pchfe" will check that size(x) >= 2 and
+    ! "x" is in strictly ascending order.
+    ! Setting "skip" to true will save time in case these checks have
+    ! already been performed (say, in "PCHIM" or "PCHIC").
+    ! "SKIP" will be set to TRUE on normal return.
+
+    real, intent(in):: XE(:) ! points at which the function is to be evaluated
+    ! NOTES:
+    ! 1. The evaluation will be most efficient if the elements of XE
+    ! are increasing relative to X.
+    ! That is,   XE(J) .GE. X(I)
+    ! implies    XE(K) .GE. X(I),  all K.GE.J
+    ! 2. If any of the XE are outside the interval [X(1),X(N)], values
+    ! are extrapolated from the nearest extreme cubic, and a warning
+    ! error is returned.
+
+    real, intent(out):: FE(:) ! values of the cubic Hermite function
+    ! defined by X, F, D at the points XE
+
+    integer, intent(out):: IERR ! error flag
+    ! Normal return:
+    ! IERR = 0  no error
+    ! Warning error:
+    ! IERR > 0  means that extrapolation was performed at IERR points
+    ! "Recoverable" errors:
+    !              IERR = -1  if N < 2
+    !              IERR = -3  if the X-array is not strictly increasing
+    !              IERR = -4  if NE < 1
+    ! NOTE: The above errors are checked in the order listed, and
+    ! following arguments have **NOT** been validated.
+
+    ! Variables local to the procedure:
+
+    INTEGER  N, NE
+
+    !---------------------------------------
+
+    n = assert_eq(size(x), size(f), size(d), "PCHFE_95 n")
+    ne = assert_eq(size(xe), size(fe), "PCHFE_95 ne")
+    call PCHFE(N, X, F, D, 1, SKIP, NE, XE, FE, IERR)
+
+  end SUBROUTINE PCHFE_95
+
+end module PCHFE_95_m
Index: trunk/LMDZ.COMMON/libf/bibio/pchsp_95_m.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/bibio/pchsp_95_m.F90	(revision 979)
+++ trunk/LMDZ.COMMON/libf/bibio/pchsp_95_m.F90	(revision 979)
@@ -0,0 +1,116 @@
+module pchsp_95_m
+
+  implicit none
+
+contains
+
+  function pchsp_95(x, f, ibeg, iend, vc_beg, vc_end)
+
+    ! PURPOSE: Set derivatives needed to determine the Hermite
+    ! representation of the cubic spline interpolant to given data,
+    ! with specified boundary conditions.
+
+    ! Part of the "pchip" package.
+
+    ! CATEGORY: E1A
+
+    ! KEYWORDS: cubic hermite interpolation, piecewise cubic
+    ! interpolation, spline interpolation
+
+    ! DESCRIPTION: "pchsp" stands for "Piecewise Cubic Hermite Spline"
+    ! Computes the Hermite representation of the cubic spline
+    ! interpolant to the data given in X and F satisfying the boundary
+    ! conditions specified by Ibeg, iend, vc_beg and VC_end.
+
+    ! The resulting piecewise cubic Hermite function may be evaluated
+    ! by "pchfe" or "pchfd".
+
+    ! NOTE: This is a modified version of C. de Boor's cubic spline
+    ! routine "cubspl".
+
+    ! REFERENCE: Carl de Boor, A Practical Guide to Splines, Springer,
+    ! 2001, pages 43-47
+
+    use assert_eq_m, only: assert_eq
+
+    real, intent(in):: x(:)
+    ! independent variable values
+    ! The elements of X must be strictly increasing:
+    !                X(I-1) < X(I),  I = 2...N.
+    !           (Error return if not.)
+    ! (error if size(x) < 2)
+
+    real, intent(in):: f(:)
+    !     dependent variable values to be interpolated
+    !  F(I) is value corresponding to X(I).
+
+    INTEGER, intent(in):: ibeg
+    !     desired boundary condition at beginning of data
+
+    !        IBEG = 0  to set pchsp_95(1) so that the third derivative is con-
+    !              tinuous at X(2).  This is the "not a knot" condition
+    !              provided by de Boor's cubic spline routine CUBSPL.
+    !              This is the default boundary condition.
+    !        IBEG = 1  if first derivative at X(1) is given in VC_BEG.
+    !        IBEG = 2  if second derivative at X(1) is given in VC_BEG.
+    !        IBEG = 3  to use the 3-point difference formula for pchsp_95(1).
+    !              (Reverts to the default boundary condition if size(x) < 3 .)
+    !        IBEG = 4  to use the 4-point difference formula for pchsp_95(1).
+    !              (Reverts to the default boundary condition if size(x) < 4 .)
+
+    !          NOTES:
+    !           1. An error return is taken if IBEG is out of range.
+    !           2. For the "natural" boundary condition, use IBEG=2 and
+    !              VC_BEG=0.
+
+    INTEGER, intent(in):: iend
+    !           IC(2) = IEND, desired condition at end of data.
+    !  IEND may take on the same values as IBEG, but applied to
+    !  derivative at X(N). In case IEND = 1 or 2, The value is given in VC_END.
+
+    !          NOTES:
+    !           1. An error return is taken if IEND is out of range.
+    !           2. For the "natural" boundary condition, use IEND=2 and
+    !              VC_END=0.
+
+    REAL, intent(in), optional:: vc_beg
+    ! desired boundary value, as indicated above.
+    !           VC_BEG need be set only if IBEG = 1 or 2 .
+
+    REAL, intent(in), optional:: vc_end
+    ! desired boundary value, as indicated above.
+    !           VC_END need be set only if Iend = 1 or 2 .
+
+    real pchsp_95(size(x))
+    ! derivative values at the data points
+    !           These values will determine the cubic spline interpolant
+    !           with the requested boundary conditions.
+    !           The value corresponding to X(I) is stored in
+    !                PCHSP_95(I),  I=1...N.
+
+    ! LOCAL VARIABLES:
+    real wk(2, size(x)) ! real array of working storage
+    INTEGER n ! number of data points
+    integer ierr, ic(2)
+    real vc(2)
+
+    !-------------------------------------------------------------------
+
+    n = assert_eq(size(x), size(f), "pchsp_95 n")
+    if ((ibeg == 1 .or. ibeg == 2) .and. .not. present(vc_beg)) then
+       print *, "vc_beg required for IBEG = 1 or 2"
+       stop 1
+    end if
+    if ((iend == 1 .or. iend == 2) .and. .not. present(vc_end)) then
+       print *, "vc_end required for IEND = 1 or 2"
+       stop 1
+    end if
+    ic = (/ibeg, iend/)
+    if (present(vc_beg)) vc(1) = vc_beg
+    if (present(vc_end)) vc(2) = vc_end
+    call PCHSP(IC, VC, N, X, F, pchsp_95, 1, WK, size(WK), IERR)
+    if (ierr /= 0) stop 1
+
+  END function pchsp_95
+
+end module pchsp_95_m
Index: trunk/LMDZ.COMMON/libf/dyn3d/comconst.h
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d/comconst.h	(revision 978)
+++ trunk/LMDZ.COMMON/libf/dyn3d/comconst.h	(revision 979)
@@ -29,4 +29,7 @@
       REAL g ! (m/s2) gravity
       REAL omeg ! (rad/s) rotation rate of the planet
+! Dissipation factors, for Earth model:
+      REAL dissip_factz,dissip_zref !dissip_deltaz
+! Dissipation factors, for other planets:
       REAL dissip_fac_mid,dissip_fac_up,dissip_deltaz,dissip_hdelta
       REAL dissip_pupstart
Index: trunk/LMDZ.COMMON/libf/dyn3d/comdissnew.h
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d/comdissnew.h	(revision 978)
+++ trunk/LMDZ.COMMON/libf/dyn3d/comdissnew.h	(revision 979)
@@ -12,8 +12,15 @@
 
       COMMON/comdissnew/ lstardis,nitergdiv,nitergrot,niterh,tetagdiv,  &
-     &                   tetagrot,tetatemp,coefdis 
+     &                   tetagrot,tetatemp,coefdis, vert_prof_dissip
 
       LOGICAL lstardis
       INTEGER nitergdiv, nitergrot, niterh
+
+! For the Earth model:
+      integer vert_prof_dissip ! vertical profile of horizontal dissipation
+!     Allowed values:
+!     0: rational fraction, function of pressure
+!     1: tanh of altitude
+
       REAL     tetagdiv, tetagrot,  tetatemp, coefdis
 
Index: trunk/LMDZ.COMMON/libf/dyn3d/conf_gcm.F
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d/conf_gcm.F	(revision 978)
+++ trunk/LMDZ.COMMON/libf/dyn3d/conf_gcm.F	(revision 979)
@@ -14,4 +14,6 @@
 #endif
       USE infotrac, ONLY : type_trac
+      use assert_m, only: assert
+
       IMPLICIT NONE
 c-----------------------------------------------------------------------
@@ -88,5 +90,6 @@
       CALL getin('lunout', lunout)
       IF (lunout /= 5 .and. lunout /= 6) THEN
-        OPEN(lunout,FILE='lmdz.out')
+        OPEN(UNIT=lunout,FILE='lmdz.out',ACTION='write', 
+     &          STATUS='unknown',FORM='formatted')
       ENDIF
 
@@ -311,4 +314,18 @@
        CALL getin('tetatemp',tetatemp )
 
+! For Earth model only:
+! Parametres controlant la variation sur la verticale des constantes de
+! dissipation.
+! Pour le moment actifs uniquement dans la version a 39 niveaux
+! avec ok_strato=y
+
+       dissip_factz=4.
+       dissip_deltaz=10.
+       dissip_zref=30.
+       CALL getin('dissip_factz',dissip_factz )
+       CALL getin('dissip_deltaz',dissip_deltaz )
+       CALL getin('dissip_zref',dissip_zref )
+
+! For other planets:
 ! Parametres controlant la variation sur la verticale des constantes de
 ! dissipation.
@@ -474,5 +491,5 @@
         write(lunout,*)'STOP !!!'
         write(lunout,*)'use_filtre_fft n est pas implemente dans dyn3d'
-        STOP
+        STOP 1
       ENDIF
       
@@ -484,4 +501,14 @@
       ok_strato=.TRUE.
       CALL getin('ok_strato',ok_strato)
+
+! NB: vert_prof_dissip is Earth-specific; should not impact other models
+      if (planet_type=="earth") then
+       vert_prof_dissip = merge(1, 0, ok_strato .and. llm==39)
+       CALL getin('vert_prof_dissip', vert_prof_dissip)
+       call assert(vert_prof_dissip == 0 .or. vert_prof_dissip ==  1,
+     $     "bad value for vert_prof_dissip")
+      else
+       vert_prof_dissip=0
+      endif
 
 !Config  Key  = ok_gradsfile
@@ -834,4 +861,5 @@
       write(lunout,*)' day_step = ', day_step
       write(lunout,*)' iperiod = ', iperiod
+      write(lunout,*)' nsplit_phys = ', nsplit_phys
       write(lunout,*)' iconser = ', iconser
       write(lunout,*)' iecri = ', iecri
Index: trunk/LMDZ.COMMON/libf/dyn3d/gcm.F
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d/gcm.F	(revision 978)
+++ trunk/LMDZ.COMMON/libf/dyn3d/gcm.F	(revision 979)
@@ -428,5 +428,5 @@
 
       CALL inidissip( lstardis, nitergdiv, nitergrot, niterh   ,
-     *                tetagdiv, tetagrot , tetatemp              )
+     *                tetagdiv, tetagrot , tetatemp, vert_prof_dissip)
 
 c-----------------------------------------------------------------------
Index: trunk/LMDZ.COMMON/libf/dyn3d/guide_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d/guide_mod.F90	(revision 978)
+++ trunk/LMDZ.COMMON/libf/dyn3d/guide_mod.F90	(revision 979)
@@ -12,4 +12,5 @@
   USE Write_Field
   use netcdf, only: nf90_nowrite, nf90_open, nf90_inq_varid, nf90_close
+  use pres2lev_mod
 
   IMPLICIT NONE
Index: trunk/LMDZ.COMMON/libf/dyn3d/inidissip.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d/inidissip.F90	(revision 978)
+++ trunk/LMDZ.COMMON/libf/dyn3d/inidissip.F90	(revision 979)
@@ -3,5 +3,5 @@
 !
 SUBROUTINE inidissip ( lstardis,nitergdiv,nitergrot,niterh  , &
-     tetagdiv,tetagrot,tetatemp             )
+     tetagdiv,tetagrot,tetatemp, vert_prof_dissip)
   !=======================================================================
   !   initialisation de la dissipation horizontale
@@ -11,5 +11,5 @@
   !   -------------
 
-  USE control_mod, only : dissip_period,iperiod
+  USE control_mod, only : dissip_period,iperiod,planet_type
 
   IMPLICIT NONE
@@ -26,4 +26,10 @@
   REAL,INTENT(in) :: tetagdiv,tetagrot,tetatemp
 
+  integer, INTENT(in):: vert_prof_dissip ! for the Earth model !!
+  ! Vertical profile of horizontal dissipation
+  ! Allowed values:
+  ! 0: rational fraction, function of pressure
+  ! 1: tanh of altitude
+
 ! Local variables:
   REAL fact,zvert(llm),zz
@@ -35,4 +41,5 @@
   INTEGER l,ij,idum,ii
   REAL tetamin
+  REAL pseudoz
   REAL Pup
   character (len=80) :: abort_message
@@ -166,15 +173,37 @@
   !   variation verticale du coefficient de dissipation:
   !   --------------------------------------------------
-
+  
+  if (planet_type.eq."earth") then
+
+   if (vert_prof_dissip == 1) then
+     do l=1,llm
+        pseudoz=8.*log(preff/presnivs(l))
+        zvert(l)=1+ &
+             (tanh((pseudoz-dissip_zref)/dissip_deltaz)+1.)/2. &
+             *(dissip_factz-1.)
+     enddo
+   else
+     DO l=1,llm
+        zvert(l)=1.
+     ENDDO
+     fact=2.
+     DO l = 1, llm
+        zz      = 1. - preff/presnivs(l)
+        zvert(l)= fact -( fact-1.)/( 1.+zz*zz )
+     ENDDO
+   endif ! of if (vert_prof_dissip == 1)
+
+  else ! other planets
+  
 ! First step: going from 1 to dissip_fac_mid (in gcm.def)
 !============
-  DO l=1,llm
+   DO l=1,llm
      zz      = 1. - preff/presnivs(l)
      zvert(l)= dissip_fac_mid -( dissip_fac_mid-1.)/( 1.+zz*zz )
-  ENDDO
-
-  write(lunout,*) 'Dissipation : '
-  write(lunout,*) 'Multiplication de la dissipation en altitude :'
-  write(lunout,*) '  dissip_fac_mid =', dissip_fac_mid
+   ENDDO
+
+   write(lunout,*) 'Dissipation : '
+   write(lunout,*) 'Multiplication de la dissipation en altitude :'
+   write(lunout,*) '  dissip_fac_mid =', dissip_fac_mid
 
 ! Second step if ok_strato:  from dissip_fac_mid to dissip_fac_up (in gcm.def)
@@ -188,5 +217,5 @@
 !   atmosphere par celui-ci.
 
-  if (ok_strato) then
+   if (ok_strato) then
 
     Pup = dissip_pupstart*exp(-0.5*dissip_deltaz/dissip_hdelta)
@@ -201,5 +230,7 @@
                    dissip_pupstart,'Pa', dissip_deltaz , '(km)'
 
-  endif
+   endif ! of if (ok_strato)
+  
+  endif ! of if (planet_type.eq."earth")
 
 
Index: trunk/LMDZ.COMMON/libf/dyn3d/pres2lev_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d/pres2lev_mod.F90	(revision 979)
+++ trunk/LMDZ.COMMON/libf/dyn3d/pres2lev_mod.F90	(revision 979)
@@ -0,0 +1,80 @@
+! $Id: pres2lev.F 1179 2009-06-11 14:18:47Z jghattas $
+!
+MODULE pres2lev_mod
+
+CONTAINS 
+
+!******************************************************
+SUBROUTINE pres2lev(varo,varn,lmo,lmn,po,pn,ni,nj,ok_invertp)
+!
+! interpolation lineaire pour passer
+! a une nouvelle discretisation verticale pour
+! les variables de GCM
+! Francois Forget (01/1995)
+! MOdif remy roca 12/97 pour passer de pres2sig
+! Modif F.Codron 07/08 po en 3D
+!**********************************************************
+
+  IMPLICIT NONE
+
+!   Declarations:
+! ==============
+!
+!  ARGUMENTS
+!  """""""""
+  LOGICAL, INTENT(IN) :: ok_invertp
+  INTEGER, INTENT(IN) :: lmo ! dimensions ancienne couches
+  INTEGER, INTENT(IN) :: lmn ! dimensions nouvelle couches
+  
+  REAL, INTENT(IN) :: po(ni*nj,lmo) ! niveau de pression ancienne grille
+  REAL, INTENT(IN) :: pn(ni*nj,lmn) ! niveau de pression nouvelle grille
+
+  INTEGER, INTENT(IN) :: ni,nj ! nombre de point horizontal
+
+  REAL, INTENT(IN)  :: varo(ni*nj,lmo) ! var dans l'ancienne grille
+  REAL, INTENT(OUT) :: varn(ni*nj,lmn) ! var dans la nouvelle grille
+
+  REAL :: zvaro(ni*nj,lmo),zpo(ni*nj,lmo)
+
+! Autres variables
+! """"""""""""""""
+  INTEGER ::  ln ,lo, k
+  REAL    :: coef
+
+
+! Inversion de l'ordre des niveaux verticaux
+  IF (ok_invertp) THEN
+    DO lo=1,lmo
+      DO k=1,ni*nj
+        zpo(k,lo)=po(k,lmo+1-lo)
+        zvaro(k,lo)=varo(k,lmo+1-lo)
+      ENDDO
+    ENDDO
+  ELSE
+    DO lo=1,lmo
+      DO k=1,ni*nj
+        zpo(k,lo)=po(k,lo)
+        zvaro(k,lo)=varo(k,lo)
+      ENDDO
+    ENDDO
+  ENDIF 
+
+  DO ln=1,lmn
+    DO lo=1,lmo-1
+      DO k=1,ni*nj
+        IF (pn(k,ln) >= zpo(k,1) ) THEN
+          varn(k,ln) = zvaro(k,1)
+        ELSE IF (pn(k,ln) <= zpo(k,lmo)) THEN
+          varn(k,ln) = zvaro(k,lmo)
+        ELSE IF ( pn(k,ln) <= zpo(k,lo) .AND. pn(k,ln) > zpo(k,lo+1) ) THEN
+          coef = (pn(k,ln)-zpo(k,lo)) / (zpo(k,lo+1)-zpo(k,lo))
+          varn(k,ln) = zvaro(k,lo) + coef*(zvaro(k,lo+1)-zvaro(k,lo))
+        ENDIF
+         
+      ENDDO  
+    ENDDO
+  ENDDO                
+
+END SUBROUTINE pres2lev    
+
+END MODULE pres2lev_mod
Index: trunk/LMDZ.COMMON/libf/dyn3dpar/abort_gcm.F
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3dpar/abort_gcm.F	(revision 978)
+++ trunk/LMDZ.COMMON/libf/dyn3dpar/abort_gcm.F	(revision 979)
@@ -1,4 +1,4 @@
 !
-! $Id: abort_gcm.F 1475 2011-01-21 14:41:03Z emillour $
+! $Id: abort_gcm.F 1748 2013-04-24 14:18:40Z emillour $
 !
 c
@@ -24,5 +24,5 @@
 
       character(len=*) modname
-      integer ierr
+      integer ierr, ierror_mpi
       character(len=*) message
 
@@ -47,5 +47,11 @@
       else
         write(lunout,*) 'Houston, we have a problem ', ierr
+#ifdef CPP_MPI
+C$OMP CRITICAL (MPI_ABORT_GCM)
+        call MPI_ABORT(COMM_LMDZ, 1, ierror_mpi)
+C$OMP END CRITICAL (MPI_ABORT_GCM)
+#else
         stop 1
+#endif          
       endif
       END
Index: trunk/LMDZ.COMMON/libf/dyn3dpar/comconst.h
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3dpar/comconst.h	(revision 978)
+++ trunk/LMDZ.COMMON/libf/dyn3dpar/comconst.h	(revision 979)
@@ -29,4 +29,7 @@
       REAL g ! (m/s2) gravity
       REAL omeg ! (rad/s) rotation rate of the planet
+! Dissipation factors, for Earth model:
+      REAL dissip_factz,dissip_zref !dissip_deltaz
+! Dissipation factors, for other planets:
       REAL dissip_fac_mid,dissip_fac_up,dissip_deltaz,dissip_hdelta
       REAL dissip_pupstart
Index: trunk/LMDZ.COMMON/libf/dyn3dpar/comdissnew.h
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3dpar/comdissnew.h	(revision 978)
+++ trunk/LMDZ.COMMON/libf/dyn3dpar/comdissnew.h	(revision 979)
@@ -12,8 +12,15 @@
 
       COMMON/comdissnew/ lstardis,nitergdiv,nitergrot,niterh,tetagdiv,  &
-     &                   tetagrot,tetatemp,coefdis 
+     &                   tetagrot,tetatemp,coefdis, vert_prof_dissip
 
       LOGICAL lstardis
       INTEGER nitergdiv, nitergrot, niterh
+
+! For the Earth model:
+      integer vert_prof_dissip ! vertical profile of horizontal dissipation
+!     Allowed values:
+!     0: rational fraction, function of pressure
+!     1: tanh of altitude
+
       REAL     tetagdiv, tetagrot,  tetatemp, coefdis
 
